# OPENQCM

## Name
openQCM Q-1 GUI Software

## Programming language
Python

## Version
2.0 beta

## Author
openQCM Team

## Supporting and powering the openQCM project
Novaetech S.r.l

## Description
An open-source Python application, to display, process and store data in real-time from the openQCM Q-1 Device.
The main functionality of the software is the real-time monitoring of frequency and dissipation variations 
of a quartz crystal microbalance through the analysis of the resonance curve.
The application uses the multiprocessing package (https://docs.python.org/3/library/multiprocessing.html).
- includes inernal and external packages

## Intended Audience
Science/Research/Engineering

## Software Development
User Interfaces

## Requirements
- Python      (https://www.python.org/).
  Packages:
  - PyQt5     (https://pypi.org/project/PyQt5/).
  - PySerial  (https://pypi.org/project/pyserial/).
  - PyQtGraph (http://www.pyqtgraph.org/).

## Other used internal packages:
- multiprocessing, numpy, scipy, setuptools, io, platform, sys, enum, argparse, cvs, time, datetime, logging

## Installation instructions:
  # Using Anaconda or Miniconda (Windows, macOS, Linux)
  1. Install [Anaconda](https://www.anaconda.com/download/) or [Miniconda](https://conda.io/miniconda.html). 
   Remember to add conda to your path.
  2. Open a terminal and type:
    - `conda install pyqtgraph pyserial`

  # Using Pip (Windows, macOS, Linux)
  1. Verify you have installed pip.
  2. Open a terminal and type:
    - `pip install PyQt5 pyqtgraph pyserial`

  # Linux (Apt based distros)
  1. Open a terminal and type:
    - `sudo apt-get install python3-pyqt5 python3-pyqtgraph python3-serial`

## Solved warning:
- If you encounter the issue below or something like this:
lib\h5py\__init__.py:36: FutureWarning: Conversion of the second argument of issubdtype from `float` to `np.floating` is deprecated. In future, it will be treated as `np.float64 == np.dtype(float).type`.
        from ._conv import register_converters as _register_converter
  the application is working properly, you can, however, fix it with this commands:
  1. Verify you have upgraded pip and, if necessary, upgrade it, open a terminal and type:
    - `python -m pip install --upgrade pip`
  2. Upgrade h5py
    - `python -m pip install --upgrade h5py`

## Usage
From a terminal, on the root folder of the project, run:
- `python -m openQCM`

## Links
- [website] https://openqcm.com/
- [github]  https://github.com/openQCM 

## Contact
- [mail] info@openqcm.com

## License and Citations
The project is distributed under GNU GPLv3 (General Public License). 
